//+------------------------------------------------------------------+
//|                                                     MACD_Bol.mq4 |
//|                         					 AK Copyright  2009 |
//|                                                                  |
//+------------------------------------------------------------------+

#define MAGICNO  20050610

extern double Lots = 0.1;


bool NewBar()
{
   static datetime dt = 0;
   if (dt != Time[0])
   {
      dt = Time[0]; Sleep(100); // wait for tick
      return(true);
   }
   return(false);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   double MACD, MACDPrevious, BolLow, BolHigh;
   int Total, Ticket, Count, FirstCross;

   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }

   MACD = iMACD(Symbol(),0,2,6,12,PRICE_CLOSE,MODE_SIGNAL,1);
   MACDPrevious = iMACD(Symbol(),0,2,6,12,PRICE_CLOSE,MODE_SIGNAL,2);
   BolLow = iBands(Symbol(),0,20,2,0,PRICE_CLOSE,MODE_LOWER,1);
   BolHigh = iBands(Symbol(),0,20,2,0,PRICE_CLOSE,MODE_UPPER,1);
   
   if ((MACDPrevious <= 0 && MACD >= 0) || (MACDPrevious >= 0 && MACD <= 0))
   {
      FirstCross = 1; 
   }
   
   Total=OrdersTotal();
   if(Total<1) 
   {
      if (AccountFreeMargin()<(1000*Lots))
      {
         Print("We Have No Money. Free Margin = ", AccountFreeMargin());
         return(0);  
      }
      
      if (NewBar())
      {
         Print("First Cross Is: ", FirstCross);
         if (FirstCross == 1)
         {
               if (Open[0] >= BolHigh) //Sell Signal
               {
                     Ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"ADV Sell",MAGICNO,0,Red);
					 return(0);
               }
               else if (Open[0] <= BolLow) //Buy Signal
               {
                     Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"ADV Buy",MAGICNO,0,Blue);
                     return(0);
               }
         }
         return(0);
      }
   }
   
   for(Count=0;Count<Total;Count++)
   {
      OrderSelect(Count, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
      {
         if(OrderType()==OP_BUY)   // Close A Long Position
         {
            if(Open[0] >= BolHigh)
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
               FirstCross = 0;
               return(0);
            }
         }
         else
         {
            if(Open[0] <= BolLow)
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
               FirstCross = 0;
               return(0);
            }
         }
      }
   }
   return(0);
}
//+------------------------------------------------------------------+